diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index 84665e3d8..b26feec9f 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -2266,7 +2266,13 @@ public class Minecraft
         int v = 0;
         while (this.currentWorld.updatingLighting()) {
             v++;
-            this.loadingScreen.progressStagePercentage((Math.min(v, count) * 100) / count);
+
+            //safety check to prevent dividing by zero
+            if (count > 0) {
+                this.loadingScreen.progressStagePercentage((Math.min(v, count) * 100) / count);
+            } else {
+                this.loadingScreen.progressStagePercentage(100);
+            }
 
             if (v >= 10000) {
                 LOGGER.error("Updating lights took to long panic skipping!");
diff --git a/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java b/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
index a8a760262..c639d33fe 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
@@ -231,14 +231,14 @@ public class TooltipElement extends Gui {
                 }
             }
 
-            if (itemStack.isItemStackDamageable() && !showDescription && GameSettings.SHOW_ITEM_DEBUG_INFO.value) {
+            if (itemStack.isItemStackDamageable() && GameSettings.SHOW_ITEM_DEBUG_INFO.value) {
                 int durability = itemStack.getMaxDamage();
                 int remainingUses = durability - itemStack.getMetadata();
 
                 text.append('\n').append(TextFormatting.LIGHT_GRAY).append(remainingUses + 1).append(" / ").append(durability + 1);
             }
 
-            if (showDescription && !debug) {
+            if (showDescription) {
                 text.append('\n').append(formatDescription(itemStack.getItemDescription()));
             } else if (!(slot instanceof SlotResult) && GameSettings.ITEM_DESCRIPTIONS.value != DescriptionPromptEnum.NEVER_PROMPT) {
                 text.append('\n').append(formatDescription(trans.translateKeyAndFormat("gui.tooltip.prompt.description", GameSettings.KEY_DESCRIPTION.getKeyName())));
diff --git a/game/client/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java b/game/client/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java
index bcbcff900..9d8b31348 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java
@@ -61,6 +61,8 @@ public class AchievementPages {
 //        netherPage.addAchievement(Achievements.ENTER_WARRENS, 0, 5);
         netherPage.addAchievement(Achievements.MOST_WANTED, 0, -1);
         netherPage.addAchievement(Achievements.FAST_TRAVEL, 0, 1);
+        netherPage.addAchievement(Achievements.GET_STEEL_BLAST_FURNACE, 0, 4);
+        netherPage.addAchievement(Achievements.OBTAIN_STEEL, -2, 4);
     }
     static {
         init();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobInfoRegistry.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobInfoRegistry.java
index d9e4ea1b1..c84a32a5d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobInfoRegistry.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobInfoRegistry.java
@@ -176,7 +176,7 @@ public abstract class MobInfoRegistry {
             20,
             1000,
             new MobDrop[] {
-                new MobDrop(new ItemStack(Items.GUNPOWDER), 0.66f, 1, 2)
+                new MobDrop(new ItemStack(Items.GUNPOWDER), 1f, 3, 16),
             }
         );
         register(MobZombiePig.class,
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
index 221b99f5e..579acb765 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
@@ -65,6 +65,11 @@ public class HudIngame extends Gui {
     private static final Logger LOGGER = LogUtils.getLogger();
     public static final Direction[] directions = new Direction[]{Direction.NORTH, Direction.EAST, Direction.SOUTH, Direction.WEST};
 
+    private static final float ACID_OVERLAY_IMMERSION_RAMP_UP = 0.055F;
+    private static final float ACID_OVERLAY_IMMERSION_RAMP_DOWN = 0.22F;
+    private static final float ACID_OVERLAY_LERP_UP = 0.13F;
+    private static final float ACID_OVERLAY_LERP_DOWN = 0.038F;
+
     private final @NotNull List<@NotNull ChatLine> chatMessageList = new ArrayList<>();
     protected Minecraft mc;
     public int updateCounter = 0;
@@ -73,6 +78,8 @@ public class HudIngame extends Gui {
     private boolean colorString = false;
     public float destroyProgress;
     float prevVignetteBrightness = 1.0f;
+    protected float acidOverlayAlpha;
+    protected float acidImmersionRamp;
     protected FontRenderer fontRenderer;
     public int chatScroll = 0;
 
@@ -110,6 +117,8 @@ public class HudIngame extends Gui {
             renderPortalOverlay(portalIntensity, width, height);
         }
 
+        updateAcidOverlayForFrame(width, height, partialTicks);
+
         for (final HudComponent component : HudComponents.INSTANCE.getComponents()) {
             if (component.isVisible()) {
                 GLRenderer.pushFrame();
@@ -701,6 +710,63 @@ public class HudIngame extends Gui {
         GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
     }
 
+    protected void updateAcidOverlayForFrame(int width, int height, float partialTicks) {
+        final Player p = this.mc.thePlayer;
+        final boolean show = p.shouldShowAcidVisualEffects() && p.getGamemode().hasToolDurability() && GameSettings.THIRD_PERSON_VIEW.value == 0;
+
+        if (p.isEffectiveInAcid() && show) {
+            this.acidImmersionRamp += (1.0F - this.acidImmersionRamp) * ACID_OVERLAY_IMMERSION_RAMP_UP;
+        } else {
+            this.acidImmersionRamp += (0.0F - this.acidImmersionRamp) * ACID_OVERLAY_IMMERSION_RAMP_DOWN;
+        }
+        if (!show) {
+            this.acidImmersionRamp = 0.0F;
+        }
+
+        final float fillNorm = Player.ACID_CYCLE_MAX > 0
+            ? MathHelper.clamp((float) p.getAcidHudBarFillTicks() / (float) Player.ACID_CYCLE_MAX, 0.0F, 1.0F)
+            : 0.0F;
+
+        final float acidTargetAlpha;
+        if (!show) {
+            acidTargetAlpha = 0.0F;
+        } else if (p.isEffectiveInAcid()) {
+            acidTargetAlpha = Math.max(fillNorm, this.acidImmersionRamp);
+        } else {
+            // Outside acid: keep overlay at full strength for the whole post-exit drain, then fade once ticks hit 0.
+            acidTargetAlpha = fillNorm > 0.0F ? 1.0F : 0.0F;
+        }
+
+        final float lerpK = acidTargetAlpha > this.acidOverlayAlpha ? ACID_OVERLAY_LERP_UP : ACID_OVERLAY_LERP_DOWN;
+        this.acidOverlayAlpha += (acidTargetAlpha - this.acidOverlayAlpha) * lerpK;
+        if (this.acidOverlayAlpha > 0.001F) {
+            renderAcidOverlay(width, height, partialTicks);
+        }
+    }
+
+    protected void renderAcidOverlay(int xSize, int ySize, float partialTicks) {
+        GLRenderer.pushFrame();
+
+        GLRenderer.disableState(State.DEPTH_TEST);
+        GLRenderer.setDepthMask(false);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+
+        // Animated acid overlay layer (vignette + drips)
+        GLRenderer.setShader(Shaders.ACID_OVERLAY);
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, this.acidOverlayAlpha);
+
+        TessellatorGeneral tess = GLRenderer.getTessellator();
+        tess.startDrawingQuads();
+        tess.addVertexWithUV(0,     ySize, -90D, 0D, 1D);
+        tess.addVertexWithUV(xSize, ySize, -90D, 1D, 1D);
+        tess.addVertexWithUV(xSize, 0,     -90D, 1D, 0D);
+        tess.addVertexWithUV(0,     0,     -90D, 0D, 0D);
+        tess.draw();
+
+        GLRenderer.popFrame();
+    }
+
     public void updateTick() {
         if (this.recordPlayingUpFor > 0) {
             this.recordPlayingUpFor--;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java
index 32c731878..85beb83ee 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java
@@ -57,6 +57,8 @@ public class HudIngameDoom
             renderPortalOverlay(portalIntensity, width, height);
         }
 
+        updateAcidOverlayForFrame(width, height, partialTicks);
+
         drawBackground();
         drawFace();
         drawAmmo();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentAcidBar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentAcidBar.java
new file mode 100644
index 000000000..841b38716
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentAcidBar.java
@@ -0,0 +1,124 @@
+package net.minecraft.client.gui.hud.component;
+
+import net.minecraft.client.gui.Gui;
+import net.minecraft.client.gui.hud.HudIngame;
+import net.minecraft.client.gui.hud.component.layout.Layout;
+import net.minecraft.client.option.GameSettings;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.entity.player.Player;
+
+public class HudComponentAcidBar extends HudComponentMovable {
+
+    private static final int ACID_BAR_MAX_ICONS = 10;
+
+    public HudComponentAcidBar(String key, Layout layout) {
+        super(key, 81, 9, layout);
+    }
+
+    private boolean isVertical() {
+        return GameSettings.VERTICAL_ACID_BAR.value;
+    }
+
+    private boolean isFlipped() {
+        return GameSettings.FLIP_ACID_BAR.value;
+    }
+
+    @Override
+    public int getDisplayedXSize() {
+        return this.isVertical() ? super.getDisplayedYSize() : super.getDisplayedXSize();
+    }
+
+    @Override
+    public int getDisplayedYSize() {
+        return this.isVertical() ? super.getDisplayedXSize() : super.getDisplayedYSize();
+    }
+
+    @Override
+    public int getTrueXSize() {
+        return this.isVertical() ? super.getTrueYSize() : super.getTrueXSize();
+    }
+
+    @Override
+    public int getTrueYSize() {
+        return this.isVertical() ? super.getTrueXSize() : super.getTrueYSize();
+    }
+
+    @Override
+    public boolean isVisible() {
+        if (mc.thePlayer == null) {
+            return GameSettings.IMMERSIVE_MODE.drawHotbar();
+        }
+        return GameSettings.IMMERSIVE_MODE.drawHotbar() &&
+            !mc.thePlayer.getGamemode().hasInvulnerablePlayer() &&
+            mc.thePlayer.getGamemode().hasToolDurability() &&
+            mc.thePlayer.shouldShowAcidVisualEffects() &&
+            !GameSettings.HIDE_ACID_BAR.value;
+    }
+
+    @Override
+    public boolean isPreviewTranslucent() {
+        return GameSettings.HIDE_ACID_BAR.value;
+    }
+
+    @Override
+    public void render(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
+        int x = this.getLayout().getComponentX(this, xSizeScreen);
+        int y = this.getLayout().getComponentY(this, ySizeScreen);
+
+        GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f);
+        GLRenderer.enableState(State.BLEND);
+
+        // One icon per acid buildup segment in fluid; after leaving fluid the bar eases down over about one second.
+        final int cycles = mc.thePlayer.getAcidHudBarFillTicks();
+        final int iconCount = cycles <= 0 ? 0 : Math.min(ACID_BAR_MAX_ICONS, cycles);
+
+        boolean isVertical = this.isVertical();
+        boolean isFlipped = this.isFlipped();
+
+        for (int i = 0; i < iconCount; i++) {
+            int xIcon;
+            int yIcon;
+
+            if (isVertical) {
+                xIcon = x;
+                yIcon = isFlipped ? (y + i * 8) : (y + (9 - i) * 8);
+            } else {
+                xIcon = isFlipped ? (x + (9 - i) * 8) : (x + i * 8);
+                yIcon = y;
+            }
+
+            hud.drawGuiIcon(xIcon, yIcon, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/acid"));
+        }
+    }
+
+    @Override
+    public void renderPreview(Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
+        int x = layout.getComponentX(this, xSizeScreen);
+        int y = layout.getComponentY(this, ySizeScreen);
+
+        GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f);
+        renderTranslucency();
+        GLRenderer.enableState(State.BLEND);
+
+        boolean isVertical = this.isVertical();
+        boolean isFlipped = this.isFlipped();
+
+        int iconCount = 6;
+        for (int i = 0; i < iconCount; i++) {
+            int xIcon;
+            int yIcon;
+
+            if (isVertical) {
+                xIcon = x;
+                yIcon = isFlipped ? (y + i * 8) : (y + (9 - i) * 8);
+            } else {
+                xIcon = isFlipped ? (x + (9 - i) * 8) : (x + i * 8);
+                yIcon = y;
+            }
+
+            gui.drawGuiIcon(xIcon, yIcon, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/acid"));
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorBar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorBar.java
index e0cb5f672..881f9afa0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorBar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorBar.java
@@ -197,8 +197,9 @@ public class HudComponentArmorBar extends HudComponentMovable {
 
         int iconY = y;
 
-        if (piece.maxDurability() > 0 && (piece.currentDurability() / piece.maxDurability()) <= 0.15 && piece.state() != ArmorState.EMPTY) {
-            this.random.setSeed(hud.updateCounter * 0x4c627L);
+        boolean inAcidWarning = mc.thePlayer != null && mc.thePlayer.shouldShowAcidVisualEffects() && mc.thePlayer.getGamemode().hasToolDurability();
+        if (piece.maxDurability() > 0 && ((piece.currentDurability() / piece.maxDurability()) <= 0.15 || inAcidWarning) && piece.state() != ArmorState.EMPTY) {
+            this.random.setSeed(hud.updateCounter * 0x4c627L + (long) this.targetShape.getSlotIndex() * 0x9e3779b9L);
             iconY += this.random.nextInt(2);
         }
 
@@ -208,7 +209,7 @@ public class HudComponentArmorBar extends HudComponentMovable {
         boolean isFlipped = this.isFlipped();
 
         hud.drawGuiIcon(x, iconY, 9, 9, getIconForState(piece, isFlipped));
-        drawDurabilityBar(hud, x, y, piece.state(), piece.currentDurability(), piece.maxDurability(), 0xFF, isFlipped);
+        drawDurabilityBar(hud, x, y, piece.state(), piece.currentDurability(), piece.maxDurability(), 0xFF, isFlipped, inAcidWarning);
 
         GLRenderer.disableState(State.BLEND);
     }
@@ -237,12 +238,12 @@ public class HudComponentArmorBar extends HudComponentMovable {
         boolean isFlipped = this.isFlipped();
 
         gui.drawGuiIcon(x, y, 9, 9, getIconForState(previewPiece, isFlipped));
-        drawDurabilityBar(gui, x, y, previewPiece.state(), previewPiece.currentDurability(), previewPiece.maxDurability(), alpha, isFlipped);
+        drawDurabilityBar(gui, x, y, previewPiece.state(), previewPiece.currentDurability(), previewPiece.maxDurability(), alpha, isFlipped, false);
 
         GLRenderer.disableState(State.BLEND);
     }
 
-    private void drawDurabilityBar(Gui gui, int x, int y, ArmorState state, double currentDurability, double maxDurability, int alpha, boolean isFlipped) {
+    private void drawDurabilityBar(Gui gui, int x, int y, ArmorState state, double currentDurability, double maxDurability, int alpha, boolean isFlipped, boolean acidWarning) {
         int barMaxWidth = 9;
         int barY = y + 10;
 
@@ -261,8 +262,16 @@ public class HudComponentArmorBar extends HudComponentMovable {
         int barWidth = (int) Math.round((currentDurability / maxDurability) * barMaxWidth);
         int progress = (int) Math.round((currentDurability / maxDurability) * 255D);
 
-        int colorFG = java.awt.Color.HSBtoRGB(progress / 255F / 3F, 1f, 1f);
-        int colorBG = ((0xFF - progress) / 4) << 16 | 0x3f00;
+        int colorFG;
+        int colorBG;
+        if (acidWarning) {
+            float t = progress / 255F;
+            colorFG = java.awt.Color.HSBtoRGB(0.11F + t * 0.06F, 1f, 1f);
+            colorBG = java.awt.Color.HSBtoRGB(0.11F, 1f, 0.35f);
+        } else {
+            colorFG = java.awt.Color.HSBtoRGB(progress / 255F / 3F, 1f, 1f);
+            colorBG = ((0xFF - progress) / 4) << 16 | 0x3f00;
+        }
 
         colorFG = (colorFG & 0x00FFFFFF) | a;
         colorBG = (colorBG & 0x00FFFFFF) | a;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorDurability.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorDurability.java
index d6526d6fd..61b62f7dc 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorDurability.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorDurability.java
@@ -12,6 +12,8 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.LightIndexHelper;
 
+import java.awt.*;
+
 public class HudComponentArmorDurability
     extends HudComponentMovable {
     private static final ItemStack[] PREVIEW_STACKS = new ItemStack[]{
@@ -53,7 +55,10 @@ public class HudComponentArmorDurability
                     float durability = (stack.getMaxDamage() - stack.getMetadata()) / (float) stack.getMaxDamage();
 
                     int l = (int) (durability * 255);
-                    final int i1 = 255 - l << 16 | l << 8;
+                    final boolean inAcidWarning = mc.thePlayer != null && mc.thePlayer.shouldShowAcidVisualEffects() && mc.thePlayer.getGamemode().hasToolDurability();
+                    final int i1 = inAcidWarning
+                        ? Color.HSBtoRGB(0.11F + (durability * 0.06F), 1f, 1f)
+                        : (255 - l << 16 | l << 8);
 
                     mc.font.render(String.valueOf((stack.getMaxDamage() - stack.getMetadata()) + 1), xx + 20, yy + 4).setShadow().setColor(i1).call();
                 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
index 6dbdda565..7e410dbd0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
@@ -104,6 +104,12 @@ public class HudComponents {
             .addAttachedOption(GameSettings.VERTICAL_FIRE_BAR, () -> new BooleanOptionComponent(GameSettings.VERTICAL_FIRE_BAR))
             .addAttachedOption(GameSettings.FLIP_FIRE_BAR, () -> new BooleanOptionComponent(GameSettings.FLIP_FIRE_BAR))
     );
+    public static final @NotNull HudComponentAcidBar ACID_BAR = register(
+        new HudComponentAcidBar("acid_bar", new LayoutSnap(FIRE_BAR, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT, 0, -1))
+            .addAttachedOption(GameSettings.HIDE_ACID_BAR, () -> new BooleanOptionComponent(GameSettings.HIDE_ACID_BAR))
+            .addAttachedOption(GameSettings.VERTICAL_ACID_BAR, () -> new BooleanOptionComponent(GameSettings.VERTICAL_ACID_BAR))
+            .addAttachedOption(GameSettings.FLIP_ACID_BAR, () -> new BooleanOptionComponent(GameSettings.FLIP_ACID_BAR))
+    );
     public static final @NotNull HudComponentRotationLock ROTATION_LOCK = register(
         new HudComponentRotationLock("rotation_lock", new LayoutSnap(CROSSHAIR, ComponentAnchor.CENTER_RIGHT, ComponentAnchor.CENTER_LEFT))
             .addAttachedKeyBinding(GameSettings.KEY_LOCK_ROTATION, () -> new KeyBindingComponent(GameSettings.KEY_LOCK_ROTATION))
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index 601296ecc..0b24fbbc7 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -181,7 +181,7 @@ public abstract class OptionsPages {
                     .withComponent(new ToggleableOptionComponent<>(GameSettings.LEAVES_QUALITY).applyOnRelease())
                     .withComponent(new ToggleableOptionComponent<>(GameSettings.PARTICLES_QUALITY))
                     .withComponent(new ToggleableOptionComponent<>(GameSettings.PARTICLES_CAP))
-                    .withComponent(new FloatOptionComponent(GameSettings.PARTICLE_RENDER_DISTANCE, 0.1f, 3f))
+                    .withComponent(new ToggleableOptionComponent<>(GameSettings.PARTICLE_RENDER_DISTANCE))
                     .withComponent(new FloatOptionComponent(GameSettings.ENTITY_RENDER_DISTANCE, 0.1f, 3f))
                     .withComponent(new BooleanOptionComponent(GameSettings.ENTITY_SHADOWS))
                     .withComponent(new ToggleableOptionComponent<>(GameSettings.CLOUD_QUALITY))
diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index c1a723abd..7710c043e 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -132,14 +132,13 @@ public final class GameSettings {
     public static final @NotNull OptionBoolean VIEW_BOBBING = register(new OptionBoolean("bobView", true));
     public static final @NotNull OptionBoolean TRANSPARENCY_DEPTH_CHECK = register(new OptionBoolean("transparencyDepthCheck", true));
     public static final @NotNull OptionEnum<ParticlesQuality> PARTICLES_QUALITY = register(new OptionEnum<>("particleQuality", ParticlesQuality.class, ParticlesQuality.ALL));
-    public static final @NotNull OptionRange PARTICLES_CAP = register(new OptionRange("particleCap", 4000, 500, 15000));
-    public static final @NotNull OptionFloat PARTICLE_RENDER_DISTANCE = register(new OptionFloat("particleRenderDistance", 1f)
-        .withDisplayStringProvider((mc, i18n, option) -> {
-            int percent = MathHelper.round(option.value * 100.0f);
-            if (percent == 100) {
-                return i18n.translateKey("options.particleRenderDistance.default");
+    public static final @NotNull OptionRange PARTICLES_CAP = register(new OptionRange("particleCap", 50000, 1000, 100000));
+    public static final @NotNull OptionRange PARTICLE_RENDER_DISTANCE = register(new OptionRange("particleRenderDistance", 12, 1, 24)
+        .addOnChangeCallback((mc, option) -> {
+            if (mc.currentScreen instanceof ScreenOptions) {
+                ScreenOptions.queueReload = true;
             } else {
-                return percent + "%";
+                mc.renderGlobal.allChanged();
             }
         }));
     public static final @NotNull OptionRange CHUNK_REBUILDS_PER_FRAME = register(new OptionRange("chunkRebuilds", 6, 2, 12));
@@ -472,6 +471,7 @@ public final class GameSettings {
     public static final @NotNull OptionBoolean HIDE_HEALTH_BAR = register(new OptionBoolean("hideHealthBar", false));
     public static final @NotNull OptionBoolean HIDE_OXYGEN_BAR = register(new OptionBoolean("hideOxygenBar", false));
     public static final @NotNull OptionBoolean HIDE_FIRE_BAR = register(new OptionBoolean("hideFireBar", false));
+    public static final @NotNull OptionBoolean HIDE_ACID_BAR = register(new OptionBoolean("hideAcidBar", false));
     public static final @NotNull OptionBoolean HIDE_VEHICLE_BAR = register(new OptionBoolean("hideVehicleBar", false));
     public static final @NotNull OptionBoolean HIDE_DYNAMIC_TOOLTIP = register(new OptionBoolean("hideDynamicTooltip", false));
     public static final @NotNull OptionBoolean HIDE_HELD_ITEM_COUNT = register(new OptionBoolean("hideHeldItemCount", true));
@@ -499,6 +499,7 @@ public final class GameSettings {
     public static final @NotNull OptionBoolean VERTICAL_OXYGEN_BAR = register(new OptionBoolean("verticalOxygenBar", false));
     public static final @NotNull OptionBoolean VERTICAL_VEHICLE_BAR = register(new OptionBoolean("verticalVehicleBar", false));
     public static final @NotNull OptionBoolean VERTICAL_FIRE_BAR = register(new OptionBoolean("verticalFireBar", false));
+    public static final @NotNull OptionBoolean VERTICAL_ACID_BAR = register(new OptionBoolean("verticalAcidBar", false));
 
     public static final @NotNull OptionBoolean FLIP_HELD_ITEM_COUNT = register(new OptionBoolean("flipHeldItemCount", false));
     public static final @NotNull OptionBoolean FLIP_HELMET_BAR = register(new OptionBoolean("flipHelmetBar", false));
@@ -509,6 +510,7 @@ public final class GameSettings {
     public static final @NotNull OptionBoolean FLIP_OXYGEN_BAR = register(new OptionBoolean("flipOxygenBar", false));
     public static final @NotNull OptionBoolean FLIP_VEHICLE_BAR = register(new OptionBoolean("flipVehicleBar", false));
     public static final @NotNull OptionBoolean FLIP_FIRE_BAR = register(new OptionBoolean("flipFireBar", false));
+    public static final @NotNull OptionBoolean FLIP_ACID_BAR = register(new OptionBoolean("flipAcidBar", false));
 
     public static final @NotNull OptionEnum<HorizontalTextAlignment> HORIZONTAL_INFO_TEXT_ALIGNMENT = register(
         new OptionEnum<>("horizontalInfoTextAlignment", HorizontalTextAlignment.class, HorizontalTextAlignment.LEFT)
@@ -693,7 +695,11 @@ public final class GameSettings {
 
                 Option<?> option = getOption(key);
                 if (option != null) {
-                    option.fromOptionsString(value);
+                    try {
+                        option.fromOptionsString(value);
+                    } catch (Exception e) {
+                        LOGGER.error("Failed to load option '{}'", option.id, e);
+                    }
                     continue;
                 }
 
diff --git a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
index 118ad0166..a9a0ac06d 100644
--- a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
+++ b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
@@ -8,8 +8,6 @@ import net.minecraft.core.InventoryAction;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicDoor;
-import net.minecraft.core.block.BlockLogicFenceGate;
-import net.minecraft.core.block.BlockLogicTrapDoor;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.Entity;
diff --git a/game/client/src/main/java/net/minecraft/client/render/ClientFireOverlayHelper.java b/game/client/src/main/java/net/minecraft/client/render/ClientFireOverlayHelper.java
new file mode 100644
index 000000000..ee6f726ce
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/ClientFireOverlayHelper.java
@@ -0,0 +1,25 @@
+package net.minecraft.client.render;
+
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.tag.BlockTags;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public final class ClientFireOverlayHelper {
+    private ClientFireOverlayHelper() {
+    }
+
+    public static @NotNull String getFireOverlayTexture(final @Nullable Entity entity) {
+        if (entity == null || entity.activeFireBlock == null) {
+            return "minecraft:block/fire";
+        }
+
+        if (entity.activeFireBlock == Blocks.FIRE_SULFURIC ||
+            entity.activeFireBlock.hasTag(BlockTags.SULFURIC_FIRE_OVERLAY_SOURCE)) {
+            return "minecraft:block/fire_sulfuric";
+        }
+
+        return "minecraft:block/fire";
+    }
+}
\ No newline at end of file
